#!/bin/sh

[ "$include_session_lock" ] && return 0
include_session_lock="$0"

SLOCK(){
  local file="$1";
  local timeout="${2-900}"
  local lockdir="$_DATA/lock/${file#$_DATA}"; lockdir="${lockdir%/}"
  local ovlock="${lockdir%/*}/delete.${lockdir##*/}"
  local tempfile="$lockdir/${SESSION_ID}"
  local lockexpire=$(( $(date +%s) - timeout ))

  mkdir -p "$_DATA/lock/${file%/*}"

  if [ -e "$lockdir" ] \
     && [ "$(stat -c %Y "$lockdir")" -lt "$lockexpire" ] \
     && mkdir "$ovlock"; then
    [ "$(stat -c %Y "$lockdir")" -lt "$lockexpire" ] \
    && rm -r "$lockdir"
    rmdir "$ovlock"
  fi

  printf '%s\n' "$tempfile"
  if mkdir "$lockdir" 2>&-; then
    cp "$file" "$tempfile"
    return 0
  else
    return 1
  fi
}

CHECK_SLOCK(){
  local file="$1";
  local lockdir="$_DATA/lock/${file#$_DATA}"; lockdir="${lockdir%/}"
  local tempfile="$lockdir/${SESSION_ID}"

  printf '%s\n' "$tempfile"
  if [ -f "$tempfile" ]; then
    touch "$lockdir"
    return 0
  else
    return 1
  fi
}

RELEASE_SLOCK(){
  local file="$1";
  local lockdir="$_DATA/lock/${file#$_DATA}"; lockdir="${lockdir%/}"
  local ovlock="${lockdir%/*}/delete.${lockdir##*/}"
  local tempfile="$lockdir/${SESSION_ID}"

  if [ -f "$tempfile" ] && mkdir "$ovlock"; then
    [ -f "$tempfile" ] && rm -r "$lockdir"
    rmdir "$ovlock"
    return 0
  else
    return 1
  fi
}
